/**
 * Opt4J is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * Opt4J is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with Opt4J. If not, see http://www.gnu.org/licenses/. 
 */

package org.opt4j.config.visualization;

import java.util.Collection;

import org.opt4j.config.PropertyModule;

/**
 * The {@code SetListener}.
 * 
 * @author lukasiewycz
 * 
 */
public interface SetListener {

	/**
	 * Invoked if a module is added.
	 * 
	 * @param collection
	 *            the collection of modules
	 * @param module
	 *            the added modules
	 */
	public void moduleAdded(Collection<PropertyModule> collection,
			PropertyModule module);

	/**
	 * Invoked if a module is removed.
	 * 
	 * @param collection
	 *            the collection of modules
	 * @param module
	 *            the removed modules
	 */
	public void moduleRemoved(Collection<PropertyModule> collection,
			PropertyModule module);

}
