package desmoj.core.util;

import java.util.Map;

/**
 * An interface for objects with parameters provided via access points
 * 
 * @version DESMO-J, Ver. 2.3.3 copyright (c) 2011
 * @author Nicolas Knaak
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You
 * may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 *
 */
public interface Parameterizable {
	
	/**
	 * Creates a map of parameters
	 * @return a map of key-value pairs where the key is a String and the value is an access point
	 */
	public Map<String, AccessPoint> createParameters(); 
}
